unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_CKProductBCPKCHZList, U_CKProductBCPKCList,
  U_CKProductBCPOutList, U_CKProductBCPInList, U_FCSMCK, U_CPHXCK, dxCore,
  ActiveX, U_CKProductBCPOutListHZ, U_CPFHSQList, U_CPSQSMCK, U_CPDBAO,
  U_CKDaBaoList, U_CPFHSQDZList, U_CPDBAOList, U_ZGYJList, U_CPFHSQYWYList,
  U_CPFHSQCWList, U_CPKCHZList, U_CPCKHZLD;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmCKProductBCPInListGL, frmCKProductBCPInListCX: TfrmCKProductBCPInList;
  frmCKProductBCPOutListGL, frmCKProductBCPOutListCX: TfrmCKProductBCPOutList;
  frmCPFHSQListLR, frmCPFHSQListSH, frmCPFHSQListCX: TfrmCPFHSQList;
  frmCKDaBaoList: TfrmCKDaBaoList;
  frmCPFHSQDZList: TfrmCPFHSQDZList;
  frmZGYJList: TfrmZGYJList;
  frmCPFHSQYWYList: TfrmCPFHSQYWYList;
  frmCPFHSQCWList: TfrmCPFHSQCWList;
  frmCKProductBCPKCHZList, frmCKProductBCPKCHZListGL: TfrmCKProductBCPKCHZList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  if Trim(DataBaseStr) = '' then
  begin
    server := '139.196.189.214,7781';
//  server := '.';
    dtbase := 'yongjindata';
//  dtbase := 'yf22000';
    user := 'yifusa';
//  user := 'sa';
    pswd := 'rightsoft@123';
//  pswd := 'rightsoft';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;

  //DName:='ADMIN';

   //DParameters1:='高权限';
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    111:  //成品入库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品入库管理' then
          begin
            BringWindowToTop(frmCKProductBCPInListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPInListGL := TfrmCKProductBCPInList.Create(application.MainForm);
          with frmCKProductBCPInListGL do
          begin
            canshu1 := '管理';
            Title := '成品入库管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPInListGL.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPInListGL.Handle;
      end;

    112:  //成品入库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品入库查询' then
          begin
            BringWindowToTop(frmCKProductBCPInListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPInListCX := TfrmCKProductBCPInList.Create(application.MainForm);
          with frmCKProductBCPInListCX do
          begin
            canshu1 := '查询';
            Title := '成品入库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPInListCX.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPInListCX.Handle;
      end;
    231:  //成品发货申请录入
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品发货申请录入' then
          begin
            BringWindowToTop(frmCPFHSQListLR.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPFHSQListLR := TfrmCPFHSQList.Create(application.MainForm);
          with frmCPFHSQListLR do
          begin
            canshu1 := '录入';
            Title := '成品发货申请录入';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPFHSQListLR.BringToFront;
       //句柄
        mnewHandle := frmCPFHSQListLR.Handle;
      end;
    232:  //成品发货申请审核
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品发货申请审核' then
          begin
            BringWindowToTop(frmCPFHSQListSH.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPFHSQListSH := TfrmCPFHSQList.Create(application.MainForm);
          with frmCPFHSQListSH do
          begin
            canshu1 := '审核';
            Title := '成品发货申请审核';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPFHSQListSH.BringToFront;
       //句柄
        mnewHandle := frmCPFHSQListSH.Handle;
      end;
    233:  //成品发货申请查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成品发货申请查询' then
          begin
            BringWindowToTop(frmCPFHSQListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPFHSQListCX := TfrmCPFHSQList.Create(application.MainForm);
          with frmCPFHSQListCX do
          begin
            canshu1 := '查询';
            Title := '成品发货申请查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPFHSQListCX.BringToFront;
       //句柄
        mnewHandle := frmCPFHSQListCX.Handle;
      end;
    241:  //单证发货确认
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '单证发货确认' then
          begin
            BringWindowToTop(frmCPFHSQDZList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPFHSQDZList := TfrmCPFHSQDZList.Create(application.MainForm);
          with frmCPFHSQDZList do
          begin
            Title := '单证发货确认';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPFHSQDZList.BringToFront;
       //句柄
        mnewHandle := frmCPFHSQDZList.Handle;
      end;
    242:  //业务员发货确认
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '业务员发货确认' then
          begin
            BringWindowToTop(frmCPFHSQYWYList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPFHSQYWYList := TfrmCPFHSQYWYList.Create(application.MainForm);
          with frmCPFHSQYWYList do
          begin
            Title := '业务员发货确认';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPFHSQYWYList.BringToFront;
       //句柄
        mnewHandle := frmCPFHSQYWYList.Handle;
      end;
    243:  //财务发货确认
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '财务发货确认' then
          begin
            BringWindowToTop(frmCPFHSQCWList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPFHSQCWList := TfrmCPFHSQCWList.Create(application.MainForm);
          with frmCPFHSQCWList do
          begin
            Title := '财务发货确认';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPFHSQCWList.BringToFront;
       //句柄
        mnewHandle := frmCPFHSQCWList.Handle;
      end;
    251:  //装柜预警
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '装柜预警' then
          begin
            BringWindowToTop(frmZGYJList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmZGYJList := TfrmZGYJList.Create(application.MainForm);
          with frmZGYJList do
          begin
            Title := '装柜预警';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmZGYJList.BringToFront;
       //句柄
        mnewHandle := frmZGYJList.Handle;
      end;
    321: // 布匹打包
      begin
        if frmCPDBao = nil then
        begin
          frmCPDBao := TfrmCPDBao.Create(application.MainForm);
          with frmCPDBao do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPDBao.BringToFront;
       //句柄
        mnewHandle := frmCPDBao.Handle;
      end;

    322: // 打包查询
      begin
        if frmCKDaBaoList = nil then
        begin
          frmCKDaBaoList := TfrmCKDaBaoList.Create(application.MainForm);
          with frmCKDaBaoList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKDaBaoList.BringToFront;
       //句柄
        mnewHandle := frmCKDaBaoList.Handle;
      end;

    323: // 仓库打包查询
      begin
        if frmCPDBAOList = nil then
        begin
          frmCPDBAOList := TfrmCPDBAOList.Create(application.MainForm);
          with frmCPDBAOList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPDBAOList.BringToFront;
       //句柄
        mnewHandle := frmCPDBAOList.Handle;
      end;

    234:  //发货申请扫描出库
      begin
        if frmCPSQSMCK = nil then
        begin
          frmCPSQSMCK := TfrmCPSQSMCK.Create(application.MainForm);
          with frmCPSQSMCK do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;           
           //show;
          end;
        end
        else
          frmCPSQSMCK.BringToFront;
       //句柄
        mnewHandle := frmCPSQSMCK.Handle;
      end;

    221:  //扫描出库
      begin
        if frmFCSMCK = nil then
        begin
          frmFCSMCK := TfrmFCSMCK.Create(application.MainForm);
          with frmFCSMCK do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmFCSMCK.BringToFront;
       //句柄
        mnewHandle := frmFCSMCK.Handle;
      end;
    222:  //回修扫描出库
      begin
        if frmCPHXCK = nil then
        begin
          frmCPHXCK := TfrmCPHXCK.Create(application.MainForm);
          with frmCPHXCK do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPHXCK.BringToFront;
       //句柄
        mnewHandle := frmCPHXCK.Handle;
      end;
    211:  //成品出库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '打卷后成品出库管理' then
          begin
            BringWindowToTop(frmCKProductBCPOutListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPOutListGL := TfrmCKProductBCPOutList.Create(application.MainForm);
          with frmCKProductBCPOutListGL do
          begin
            canshu1 := '管理';
            Title := '打卷后成品出库管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPOutListGL.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPOutListGL.Handle;
      end;
    212:  //成品出库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '打卷后成品出库查询' then
          begin
            BringWindowToTop(frmCKProductBCPOutListCX.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPOutListCX := TfrmCKProductBCPOutList.Create(application.MainForm);
          with frmCKProductBCPOutListCX do
          begin
            canshu1 := '查询';
            Title := '打卷后成品出库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPOutListCX.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPOutListCX.Handle;
      end;
    213:  //成品出库汇总
      begin
        if frmCKProductBCPOutListHZ = nil then
        begin
          frmCKProductBCPOutListHZ := TfrmCKProductBCPOutListHZ.Create(application.MainForm);
          with frmCKProductBCPOutListHZ do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPOutListHZ.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPOutListHZ.Handle;
      end;
    215:  //理单统计查询
      begin
        if frmCPCKHZLD = nil then
        begin
          frmCPCKHZLD := TfrmCPCKHZLD.Create(application.MainForm);
          with frmCPCKHZLD do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPCKHZLD.BringToFront;
       //句柄
        mnewHandle := frmCPCKHZLD.Handle;
      end;
    311:  //库存列表
      begin
        if frmCKProductBCPKCList = nil then
        begin
          frmCKProductBCPKCList := TfrmCKProductBCPKCList.Create(application.MainForm);
          with frmCKProductBCPKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPKCList.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPKCList.Handle;
      end;

    312:  //打卷后成品库存汇总库龄查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '打卷后成品库存汇总库龄查询' then
          begin
            BringWindowToTop(frmCKProductBCPKCHZList.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPKCHZList := TfrmCKProductBCPKCHZList.Create(application.MainForm);
          with frmCKProductBCPKCHZList do
          begin
            canshu1 := '查询';
            Title := '打卷后成品库存汇总库龄查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPKCHZList.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPKCHZList.Handle;
      end;
    313:  //成品库存汇总管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '打卷后成品库存汇总管理' then
          begin
            BringWindowToTop(frmCKProductBCPKCHZListGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCKProductBCPKCHZListGL := TfrmCKProductBCPKCHZList.Create(application.MainForm);
          with frmCKProductBCPKCHZListGL do
          begin
            canshu1 := '管理';
            Title := '打卷后成品库存汇总管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCKProductBCPKCHZListGL.BringToFront;
       //句柄
        mnewHandle := frmCKProductBCPKCHZListGL.Handle;
      end;
    314:  //打卷后成品库存汇总查询
      begin
        if frmCPKCHZList = nil then
        begin
          frmCPKCHZList := TfrmCPKCHZList.Create(application.MainForm);
          with frmCPKCHZList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPKCHZList.BringToFront;
       //句柄
        mnewHandle := frmCPKCHZList.Handle;
      end;
  end;

  Result := mnewHandle;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_FinishedClothWarehouse) then
    DataLink_FinishedClothWarehouse := TDataLink_FinishedClothWarehouse.Create(Application);
  try
    with DataLink_FinishedClothWarehouse.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_FinishedClothWarehouse.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

